#--*-coding:utf-8-*--

class JekyllandHyde < DiceBot
  
  def initialize
    super
    @sendMode = 2
    @sortType = 1
    @d66Type = 2
  end
  def gameName
    'ジキルとハイドとグリトグラ'
  end
  
  def gameType
    "JekyllandHyde"
  end
  
  def prefixs
    ['(RC\d+|DDC|GOALT).*']
  end
  
  def getHelpMessage
    info = <<INFO_MESSAGE_TEXT
・難易度算出コマンド　DDC
・判定コマンド　RCx（x＝難易度）
・目標決定表　GOALT
ジキルとハイドとグリトグラ　byかむらい
INFO_MESSAGE_TEXT
  end
  
  
  
  def rollDiceCommand(command)
    debug("rollDiceCommand begin string", command)
    
    result = ''
    
    result = checkRoll(command)
    return result unless(result.empty?)
    
    
    debug("各種表として処理")
    return rollTableCommand(command)
  end
  
  
  def checkRoll(string)
    debug("checkRoll begin string", string)
    
    return '' unless(/^RC(\d+)(([+]|[-])(\d+))?$/i =~ string)
    
    target = $1.to_i
    operator = $3
    value = $4.to_i
    modify = 0
    
    result = "判定　難易度：#{target}　"
    
    unless( operator.nil? )
      modify = value  if( operator == "+")
      modify = value * (-1)  if( operator == "-")
      result += "修正値：#{modify}　"
    end
    
            
        d1, = roll(1, 6)
        d2, = roll(1, 6)

        result += "＞　出目：#{d1}、#{d2}　＞　"
     
     if(d1==d2)
        result += "ゾロ目！【Ｃｒｉｔｉｃａｌ】"
     elsif(d1+d2==7)
		result += "ダイスの出目が表裏！【Ｆｕｍｂｌｅ】"
	 elsif(d1+d2+modify>=target)
	    result += "#{d1+d2+modify}、難易度以上！【Ｓｕｃｃｅｓｓ】"
	 else
	    result += "#{d1+d2+modify}、難易度未満！【Ｍｉｓｓ】"
	 end

    return result
  end

  
  ####################
  # 各種表
  
  def rollTableCommand(command)
    command = command.upcase
    result = []
    
    debug("rollDiceCommand command", command)
    
    counts = 1
    
    case command
    when "DDC"
      result = choiceddcTable(counts)
    when "GOALT"
      result = choicegoalTable(counts)
    else
      return
    end
    
    return result
  end


###呼び出し＋α

  def choiceddcTable(counts)
      
      name = "難易度決定"
      text = "#{name}："      

      d1, = roll(1, 6)
      d2, = roll(1, 6)
      text += "　出目：#{d1}、#{d2}　＞　"
      
      if(d1>=d2)
        text += "#{d1}－#{d2}＝#{d1-d2}　＞　難易度#{5+(d1-d2)}"
      else
        text += "#{d2}－#{d1}＝#{d2-d1}　＞　難易度#{5+(d2-d1)}"
      end

     return text
  end


  def choicegoalTable(counts)
      
      name = "目標決定表"
      text = "#{name}:"   
      
         d1, = roll(1, 6)

    case d1
    when 1
      text += "出目1　＞　「主人格の目的達成」"
    when 2
      text += "出目2　＞　「主人格の目的阻害」"
    when 3
      text += "出目3　＞　「主人格のハッピーエンド（目的達成しなくてもよい）」"
    when 4
      text += "出目4　＞　「主人格のバッドエンド（目的達成していてもよい）」"
    when 5
      text += "出目5　＞　「自分の人格が目的を決定できる」"
    when 6
      text += "出目6　＞　「主人格の目的達成」「主人格の目的阻害」「主人格のハッピーエンド（目的達成しなくてもよい）」「主人格のバッドエンド（目的達成していてもよい）」「自分の人格が目的を決定できる」のどれかを自由に選べる"
    else
      return
    end

     return text
  end
  
end